/* ***************************************************************************
 *
 *	This program is free software; you can redistribute it and/or modify it
 * 	under the terms of the Shared Code License (SCL) version 1.0 as published
 *	by www.IntellectualHeaven.com. You should have received a copy of the SCL
 *	1.0 license, look for file license.txt, along with this software; if not,
 *	then please write to x_pankaj_x@intellectualheaven.com for an electronic
 *	copy of the same.
 *
 * File name:
 * 		TCPFire.cpp
 * 
 * Description:
 * 		This file implements application entry point i.e. WinMain
 * 	
 * Revision:
 * --------------------------------------------------------------------------
 *		2005-04-24	xpankajx@intellectualheaven.com
 *		First version
 * --------------------------------------------------------------------------
 * 	Copyright (c) : Pankaj Garg
 * **************************************************************************/

//** System Include Files
#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>

//** Local Include Files
#include "SfGuiTypes.h"
#include "SfGui.h"
#include "SfGuiView.h"
#include "SfGuiRes.h"


/*
 * Global view object
 */
CSfGuiView *g_pViewObj = NULL;


/****************************************************************************
 *  FUNCTION NAME:  WndProc
 *
 *  DESCRIPTION:    Windows main message handling function
 *
 *  INPUTS:         hwnd - Handle to associated window
 *                  nMsg - Message to Handle
 *                  wParam - 
 *                  lParam - 
 *
 *  RETURNS:        LRESULT
 *
 *  NOTES:          
 *
 ***************************************************************************/
LRESULT CALLBACK 
WndProc(    HWND hwnd,
            UINT nMsg,
            WPARAM wParam,
            LPARAM lParam)
{
    return g_pViewObj->WndProc( hwnd,
                                nMsg,
                                wParam,
                                lParam);
}



/****************************************************************************
 *  FUNCTION NAME:  WinMain
 *
 *  DESCRIPTION:    Entry point for MIDiff
 *
 *  INPUTS:         hInstance - 
 *                  hPrevInstance - 
 *                  szCmdLine - Command line arguments
 *                  iCmdShow - 
 *
 *  RETURNS:        LRESULT
 *
 *  NOTES:          
 *
 ***************************************************************************/
int WINAPI
WinMain(    HINSTANCE hInstance,
            HINSTANCE /* hPrevInstance */,
            PSTR  /* szCmdLine */,
            int /* iCmdShow */)
{
    MSG msg;

    g_pViewObj = new CSfGuiView(hInstance);

    if (!g_pViewObj)
    {
        ::MessageBox(   NULL,
                        L"Memory allocation failure.....\n",
                        L"Resource Error",
                        MB_OK);
        return 0;
    }
    
    g_pViewObj->InitInstance();


    /*
     * Message loop
     */
    while(GetMessage(&msg,NULL,0,0))
    {
		if (!TranslateAccelerator(msg.hwnd, g_pViewObj->GetAccel(), &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }

    delete g_pViewObj;

    return msg.wParam;
}

